using System;
using System.Data;
using System.Globalization;
using System.Resources;
using System.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using NPOI.HSSF.UserModel;
using NPOI.SS.UserModel;
using System.IO;
using NPOI.HSSF.Util;
using System.Web;
using NPOI.SS.Util;
public partial class Reports_TA_UI_Report_ManualTimeEntry : Base.BasePage
{
    #region Variable Declaration
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    GetReports rptEmp = new GetReports();
    Rpt_Common rptcommon = new Rpt_Common();
    cls_Common objCommon = new cls_Common();
    //EntranceEventData objEntrance = new EntranceEventData();
    EmployeeEventData objEmployee = new EmployeeEventData();
    ResourceManager rm;
    CultureInfo ci;
    string strFromdate, gstrDateFormat, strTodate;
    int intIndividualUser = 0;
    #endregion
    #region PageLoad
    /// <summary>
    /// On page loading
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected override void Page_Load(object sender, EventArgs e)
    {

        // session checking
        base.Page_Load(sender, e);
        if (!Page.IsPostBack)
        {
            base.CheckPages(0);
            objCommon.menu("ManualReports", "92");
        }
        //get the culture info to set the language        
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        LoadStrings(ci);
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_EnterDate", ci) + "','" + rm.GetString("Alert_EnterToDate", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validmonthdatefourdigit", ci) + "','" + rm.GetString("Alert_Validdatemonthfourdigit", ci) + "','" + rm.GetString("Alert_Invalidyearentry", ci) + "','" + rm.GetString("Alert_Invalidmonthentry", ci) + "','" + rm.GetString("Alert_Invaliddateentry", ci) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", ci) + "','" + rm.GetString("Alert_Entertime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "','" + rm.GetString("Alert_Invalidtimeformat1", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        //Set UserRights
        UserRights();
        if (!IsPostBack)
        {
            if (Request.QueryString["Source"] != null)
            {
                if (Convert.ToString(Request.QueryString["Source"]) == "Email")
                {
                    divdateTime.Visible = false;
                    trView.Visible = false;
                    trSave.Visible = true;
                }
            }
            else
            {
                divdateTime.Visible = true;
                trView.Visible = true;
                trSave.Visible = false;
            }
            if (Request.QueryString["ScheduleId"] != null)
            {
                string strGet = hdnReportFilters.Value;
                string strScript = "<script language='javascript' type='text/javascript'>";
                strScript += "GethiddenValue();";
                strScript += " </script>";
                this.RegisterStartupScript("setScript", strScript);
                DataSet ds = new DataSet();
                ds = rptEmp.GetEmailSchedulerFilterDetails(Convert.ToInt32(Request.QueryString["ScheduleId"]));
                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows.Count > 0)
                    {
                        txtEmployeeId.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeId"]);
                        txtEmployeeName.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeName"]);
                        ddlEmpCatagory.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeCategory"]);
                        ddlEmpType.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeType"]);
                        ddlDesignation.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["DesignationID"]);
                        ddlGender.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["Gender"]);
                        ddlManualEntryStatus.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["Status"]);
                        Session["EMailParentId"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentID"]);
                    }
                }
            }
            else
            {
                if (Convert.ToString(Session["hdnReportFilters"]) != string.Empty)
                {
                    string strhdnParameters = Convert.ToString(Session["hdnReportFilters"]);
                    string[] strArray = new string[50];
                    string[] strArray1 = new string[50];
                    strArray = strhdnParameters.Split(',');
                    for (int i = 0; i < strArray.Length; i++)
                    {
                        string[] strTemp = new string[5];
                        strTemp = strArray[i].Split('=');
                        strArray1[i] = strTemp[1];
                    }
                    txtEmployeeName.Text = Convert.ToString(strArray1[3]).Replace("~", ",");
                    txtEmployeeId.Text = Convert.ToString(strArray1[2]).Replace("~", ",");
                    ddlEmpCatagory.SelectedValue = Convert.ToString(strArray1[5]);
                    ddlEmpType.SelectedValue = Convert.ToString(strArray1[6]);
                    ddlDesignation.SelectedValue = Convert.ToString(strArray1[12]);
                    ddlGender.SelectedValue = Convert.ToString(strArray1[13]);
                    ddlManualEntryStatus.SelectedValue = Convert.ToString(strArray1[11]);
                    Session["EMailParentId"] = Convert.ToString(strArray1[10]);
                }
            }
            if (Session["parentLevelId"] != null || Convert.ToInt16(Session["parentLevelId"]) != 0)
            {
                Session["parentLevelId"] = null;
            }
            Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
            // Bindings the employee category and type.
            BindingEmployeeCategoryandType();
            FillDesignation();
            ddlDesignation.PreRender += LB_PreRender;
            txtFromDate.Text = (Convert.ToDateTime(objCommon.CurrentMonthStartDate())).ToString(Session["MDateFormat"].ToString());
            txtToDate.Text = (Convert.ToDateTime(System.DateTime.Now.ToShortDateString())).ToString(Session["MDateFormat"].ToString());
        }
        else
        {
            if (Request.QueryString["Source"] != null)
            {
                if (Convert.ToString(Request.QueryString["Source"]) == "Email")
                {
                    divdateTime.Visible = false;
                    trView.Visible = false;
                    trSave.Visible = true;
                }
            }
            else
            {
                divdateTime.Visible = true;
                trView.Visible = true;
                trSave.Visible = false;
            }
        }
        //Check whether the employee is Individual User
        intIndividualUser = objCheckUser.CheckIndividualUser(Convert.ToString(Session["UserGroupName"]));
        if (intIndividualUser >= 1)
        {
            PlaceHolderManualEntry.Controls.Clear();
            divEmployeeDetails.Visible = false;
            lblEmpSwipe.Visible = false;
            txtSwipeCard.Visible = false;
        }
        //Convert date time to MM/dd/YYYY format
        gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
        strFromdate = txtFromDate.Text;
        strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
        strTodate = txtToDate.Text;
        strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
        int manualEntryExists = 0;
        manualEntryExists = objCommon.CheckPageExistsInLicense(98);
        if (manualEntryExists == 0)
        {
            strlblStatus.Style.Add("display", "none");
        }
        if (Convert.ToString(Page.MasterPageFile) == "TA_Popup_Report_MasterPage.master")
        {
            conHeader.Visible = false;
        }
    }
    protected void Page_PreInit(object sender, EventArgs e)
    {
        if (Request.QueryString["Source"] != null)
            this.Page.MasterPageFile = "TA_Popup_Report_MasterPage.master";
    }
    #endregion
    #region User Defined function
    /// <summary>
    /// Fills the designation in the drop down
    /// </summary>
    private void FillDesignation()
    {
        DataSet ds_designation = new DataSet();
        ds_designation = objEmployee.select_CommonDesignation();
        if (ds_designation != null)
        {
            if (ds_designation.Tables[0].Rows.Count > 0)
            {
                ddlDesignation.DataSource = ds_designation;
                ddlDesignation.DataTextField = "TitleName";
                ddlDesignation.DataValueField = "TitleId";
                ddlDesignation.DataBind();
            }
            ds_designation.Dispose();
            foreach (ListItem item in ddlDesignation.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
    }
    /// <summary>
    /// Bindings the employee category and type.
    /// </summary>
    private void BindingEmployeeCategoryandType()
    {
        // employee category binding
        DataSet dsCategory = new DataSet();
        dsCategory = objEmployee.SelectCategoryDetailsEmployee("");
        if (dsCategory != null)
        {
            if (dsCategory.Tables[0].Rows.Count > 0)
            {
                ddlEmpCatagory.DataSource = dsCategory;
                ddlEmpCatagory.DataTextField = "CategoryName";
                ddlEmpCatagory.DataValueField = "CategoryId";
                ddlEmpCatagory.DataBind();
            }
            dsCategory.Dispose();
            foreach (ListItem item in ddlEmpCatagory.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
        // employee type binding
        DataSet dsType = new DataSet();
        dsType = objEmployee.SelectTypeDetailsEmployee("");
        if (dsType != null)
        {
            if (dsType.Tables[0].Rows.Count > 0)
            {
                ddlEmpType.DataSource = dsType;
                ddlEmpType.DataTextField = "TypeName";
                ddlEmpType.DataValueField = "TypeId";
                ddlEmpType.DataBind();
            }
            dsType.Dispose();
            foreach (ListItem item in ddlEmpType.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
    }
    /// <summary>
    /// Validate the FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateFromDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date.ToString("MM/dd/yyyy")); ;
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day <= 0)
                e.IsValid = true;
            else
            {
                base.Message(rm.GetString("Alert_EnterValidFromDate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    /// <summary>
    /// Validate the ToDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateToDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strTodate = txtToDate.Text;
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date.ToString("MM/dd/yyyy"));
            DateTime dtFromDate = DateTime.Parse(strTodate);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day <= 0)
                e.IsValid = true;
            else
            {
                base.Message(rm.GetString("Alert_EnterValidToDate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    /// <summary>
    /// Compare ToDate with FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void CompareDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            strTodate = txtToDate.Text;
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            DateTime dtToDate = DateTime.Parse(strTodate);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan diff = dtToDate.Subtract(dtFromDate);
            int day = diff.Days;
            if (day >= 0)
                e.IsValid = true;
            else
            {
                //base.Message("Select valid date compare with Fromdate");
                base.Message(rm.GetString("Msg_SelectvaliddatecomparewithFromdate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    /// <summary>
    /// To assign the label names according to the selected language
    /// </summary>
    /// <param name="ci"></param>
    private void LoadStrings(CultureInfo ci)
    {
        lblFilter.Text = rm.GetString("lblFilter", ci);
        btn_View.Text = "&nbsp;&nbsp;" + rm.GetString("btn_View", ci);
        lblManualTimeEntry.Text = rm.GetString("Report_ManualTimeEntrys", ci);
        lblEmployeeName.Text = rm.GetString("email_EmployeeName", ci);
        lblEmployeeId.Text = rm.GetString("email_EmployeeId", ci);
        lblEmpCategory.Text = rm.GetString("Master_Category", ci);
        lblEmpType.Text = rm.GetString("Master_Type", ci);
        lblTimePeriod.Text = rm.GetString("Reports_TimePeriod", ci);
        lblFrom.Text = rm.GetString("email_FromDate", ci);
        lblTo.Text = rm.GetString("email_ToDate", ci);
        lblStatus.Text = rm.GetString("email_Status", ci);
        lblEmpSwipe.Text = rm.GetString("TerminalDataType_Card_No", ci);
        ddlManualEntryStatus.Items[0].Text = rm.GetString("ExportData_All", ci);
        ddlManualEntryStatus.Items[1].Text = rm.GetString("btn_Approved", ci);
        ddlManualEntryStatus.Items[2].Text = rm.GetString("btn_Forwarded", ci);
        ddlManualEntryStatus.Items[3].Text = rm.GetString("btn_Pending", ci);
        ddlManualEntryStatus.Items[4].Text = rm.GetString("btn_Reject", ci);
        ddlEmpCatagory.Items[0].Text = rm.GetString("Select", ci);
        ddlEmpType.Items[0].Text = rm.GetString("Select", ci);
        reqToDate.ErrorMessage = rm.GetString("Alert_PleaseselectToDate", ci);
        lblDesignation.Text = rm.GetString("EmployeeMaster_Designation", ci);
        lblGender.Text = rm.GetString("EmployeeMaster_Gender", ci);
        ddlGender.Items[0].Text = rm.GetString("Caption_Both", ci);
        ddlGender.Items[1].Text = rm.GetString("rbtn_EmployeeMaster_Male", ci);
        ddlGender.Items[2].Text = rm.GetString("rbtn_EmployeeMaster_Female", ci);
        ddlDesignation.Items[0].Text = rm.GetString("ExportData_All", ci);
        btnSave.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Save", ci);
        btnBack.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Cancel", ci);
        lblDateFilter.Text = rm.GetString("lbl_DateFilter", ci);
        btn_Export.Text = "&nbsp;&nbsp;" + rm.GetString("btn_ExporttoExcel", ci);
        rbCustom.Text = rm.GetString("rb_Custom", ci);
        rbpreviousMonth.Text = rm.GetString("rb_PreviousMonth", ci);
        rbpreviousweek.Text = rm.GetString("rb_PreviousWeek", ci);
        rbThisMonth.Text = rm.GetString("rb_ThisMonth", ci);
        rbThisweek.Text = rm.GetString("rb_ThisWeek", ci);

    }
    /// <summary>
    /// To check rights for the logged in user
    /// </summary>
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(92, Convert.ToInt32(Session["userGroup_Id"]), "viewPrv");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["viewPrv"] == DBNull.Value || Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) == 1)
            {
                btn_View.Visible = true;
            }
            else
            {
                btn_View.Visible = false;
            }
        }
        else
        {
            Response.Redirect("ReportsLandingPage.aspx");
        }
    }
    /// <summary>
    /// To apply tooltip for the designation in the drop down
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void LB_PreRender(object sender, System.EventArgs e)
    {
        foreach (ListItem item in ddlDesignation.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
    /// <summary>
    /// Export to excel Functionality operation
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ExportExcel(DataSet dsEmp, DataTable dtLevelName)
    {
        HSSFWorkbook workbook = new HSSFWorkbook();
        ISheet sheet = workbook.CreateSheet("Manual Time Entry Report");
        int rowIndex = 0;

        NPOI.SS.UserModel.IRow row = sheet.CreateRow(rowIndex);
        HSSFFont hFont = (HSSFFont)workbook.CreateFont();
        hFont.Boldweight = (short)FontBoldWeight.Bold;
        hFont.Color = HSSFColor.Maroon.Index;
        hFont.FontHeightInPoints = 10;
        HSSFCellStyle hStyle = (HSSFCellStyle)workbook.CreateCellStyle();
        hStyle.SetFont(hFont);
        hStyle.FillForegroundColor = IndexedColors.White.Index;
        hStyle.FillPattern = FillPattern.SolidForeground;
        hStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
        hStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
        hStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
        hStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
        HSSFCellStyle MainStyle = (HSSFCellStyle)workbook.CreateCellStyle();
        MainStyle.SetFont(hFont);
        MainStyle.Alignment = HorizontalAlignment.Center;

        HSSFCellStyle hStyle2 = (HSSFCellStyle)workbook.CreateCellStyle();
        hStyle2.SetFont(hFont);
        HSSFCellStyle IStyle = (HSSFCellStyle)workbook.CreateCellStyle();
        IStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
        IStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
        IStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
        IStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;

        if (dtLevelName.Rows.Count > 0)
        {
            row.CreateCell(0).SetCellValue(Convert.ToString(dtLevelName.Rows[0][0]));
            sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, 13));
            row.GetCell(0).CellStyle = MainStyle;
            rowIndex++;
            row = sheet.CreateRow(rowIndex);
        }
        row.CreateCell(0).SetCellValue("Manual Time Entry Report From - " + Convert.ToString(txtFromDate.Text) + " To - " + Convert.ToString(txtToDate.Text));
        row.GetCell(0).CellStyle = MainStyle;
        sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, 13));
        rowIndex++;
        row = sheet.CreateRow(rowIndex);
        rowIndex++;
        row = sheet.CreateRow(rowIndex);
        row.CreateCell(0).SetCellValue("Sl.No");
        row.CreateCell(1).SetCellValue("Employee Id");
        row.CreateCell(2).SetCellValue("Employee Name");
        row.CreateCell(3).SetCellValue("Level");
        row.CreateCell(4).SetCellValue("Gender");
        row.CreateCell(5).SetCellValue("Raised By");
        row.CreateCell(6).SetCellValue("Raised On");
        row.CreateCell(7).SetCellValue("Entry Type");
        row.CreateCell(8).SetCellValue("In Date");
        row.CreateCell(9).SetCellValue("In Time");
        row.CreateCell(10).SetCellValue("Out Date");
        row.CreateCell(11).SetCellValue("Out Time");
        row.CreateCell(12).SetCellValue("Status");
        row.CreateCell(13).SetCellValue("Reason");

        //row.RowStyle = hStyle;
        for (int i = 0; i <= 13; i++)
        {
            row.GetCell(i).CellStyle = hStyle;
        }
        rowIndex++;
        string strPre = string.Empty; int EmployeeDatacount = 1;
        //string OldEmployeeId = "0";
        //string PreviousEmployeeId = "-1";
        //Int64 Total = 0;
        //string column = "";
        foreach (DataRow DR in dsEmp.Tables[0].Rows)
        {
            row = sheet.CreateRow(rowIndex);

            if (strPre == string.Empty || strPre != Convert.ToString(DR["ManualTimeEntry_Employee_Id"]))
            {
                row.CreateCell(0).SetCellValue(Convert.ToString(EmployeeDatacount));
                EmployeeDatacount++;
            }
            else
            {
                row.CreateCell(0).SetCellValue(string.Empty);
            }
            row.CreateCell(1).SetCellValue(Convert.ToString(DR["ManualTimeEntry_Employee_Id"]));
            row.CreateCell(2).SetCellValue(Convert.ToString(DR["Employee_Name"]));
            row.CreateCell(3).SetCellValue(Convert.ToString(DR["name"]));
            row.CreateCell(4).SetCellValue(Convert.ToString(DR["Gender"]));
            row.CreateCell(5).SetCellValue(Convert.ToString(DR["Created_By"]));
            row.CreateCell(6).SetCellValue(Convert.ToString(DR["Created_DateTime"]));
            row.CreateCell(7).SetCellValue(Convert.ToString(DR["IsDiscrepancyEntry"]));
            row.CreateCell(8).SetCellValue(Convert.ToString(DR["ManualTimeEntry_InDate"]));
            row.CreateCell(9).SetCellValue(Convert.ToString(DR["ManualTimeEntry_InTime"]));
            row.CreateCell(10).SetCellValue(Convert.ToString(DR["ManualTimeEntry_OutDate"]));
            row.CreateCell(11).SetCellValue(Convert.ToString(DR["ManualTimeEntry_OutTime"]));
            row.CreateCell(12).SetCellValue(Convert.ToString(DR["ManualTimeEntry_Status"]));
            row.CreateCell(13).SetCellValue(Convert.ToString(DR["ManualTimeEntry_Reason"]));
            strPre = Convert.ToString(DR["ManualTimeEntry_Employee_Id"]);
            for (int i = 0; i <= 13; i++)
            {
                row.GetCell(i).CellStyle = IStyle;
                sheet.AutoSizeColumn(i);
            }
            rowIndex++;
        }
        ISheet sheet1 = workbook.CreateSheet("Legends");
        sheet1.IsPrintGridlines = true;
        sheet1.VerticallyCenter = true;
        int rowIndex1 = 0;
        NPOI.SS.UserModel.IRow row1 = sheet1.CreateRow(rowIndex1);
        hFont = (HSSFFont)workbook.CreateFont();
        hFont.Boldweight = (short)FontBoldWeight.Bold;
        hFont.Color = HSSFColor.Red.Index;
        hFont.FontHeightInPoints = 10;
        hStyle = (HSSFCellStyle)workbook.CreateCellStyle();
        hStyle.SetFont(hFont);
        hStyle.FillForegroundColor = IndexedColors.White.Index;
        hStyle.FillPattern = FillPattern.SolidForeground;
        HSSFCellStyle hStyle1 = (HSSFCellStyle)workbook.CreateCellStyle();
        hStyle1.SetFont(hFont);
        hStyle1.FillForegroundColor = IndexedColors.Pink.Index;
        hStyle1.FillPattern = FillPattern.SolidForeground;
        HSSFFont hFont1 = (HSSFFont)workbook.CreateFont();
        hFont1.Boldweight = (short)FontBoldWeight.Bold;
        hFont1.Color = HSSFColor.Pink.Index;
        hFont1.FontHeightInPoints = 10;
        HSSFCellStyle hStyle3 = (HSSFCellStyle)workbook.CreateCellStyle();
        hStyle3.SetFont(hFont1);
        hStyle3.FillForegroundColor = IndexedColors.White.Index;
        hStyle3.FillPattern = FillPattern.SolidForeground;
        row1.CreateCell(0).SetCellValue("");
        row1.CreateCell(1).SetCellValue("M-Manual Entry");
        sheet1.AddMergedRegion(new CellRangeAddress(rowIndex1, rowIndex1, 1, 5));
        row1.GetCell(1).CellStyle = hStyle;
        rowIndex1++;
        row1 = sheet1.CreateRow(rowIndex1);
        row1.CreateCell(0).SetCellValue("");
        row1.CreateCell(1).SetCellValue("D-Discrepancy Entry");
        sheet1.AddMergedRegion(new CellRangeAddress(rowIndex1, rowIndex1, 1, 5));
        row1.GetCell(1).CellStyle = hStyle;
        rowIndex1++;


        using (MemoryStream exportData = new MemoryStream())
        {
            workbook.Write(exportData);
            workbook.WriteProtectWorkbook("sa", "");
            string saveAsFileName;
            saveAsFileName = string.Format("ManualTimeEntryReport-{0:d}.xls", DateTime.Now).Replace("/", "-");
            Response.ContentType = "application/vnd.ms-excel";
            Response.AddHeader("Content-Disposition", string.Format("attachment;filename={0}", saveAsFileName));
            Response.Clear();
            Response.BinaryWrite(exportData.GetBuffer());
            //Response.End();
            HttpContext.Current.ApplicationInstance.CompleteRequest();
        }

    }

    #endregion
    #region Button Event
    /// <summary>
    /// To pass the filter parameters to the report viewer page.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btn_View_Click(object sender, EventArgs e)
    {
        //int employeeCategory = 0, employeeType = 0;
        string strStatus = "All";
        try
        {
            if (Page.IsValid == true)
            {
                string dtFrom = strFromdate;
                string dtTo = strTodate;
                //// set employee category and type
                //if (Convert.ToInt32(ddlEmpCatagory.SelectedValue) != 0)
                //{
                //    employeeCategory = Convert.ToInt32(ddlEmpCatagory.SelectedValue);
                //}
                //else
                //{
                //    employeeCategory = 0;
                //}
                //if (Convert.ToInt32(ddlEmpType.SelectedValue) != 0)
                //{
                //    employeeType = Convert.ToInt32(ddlEmpType.SelectedValue);
                //}
                //else
                //{
                //    employeeType = 0;
                //}
                if (ddlManualEntryStatus.SelectedValue == "Approved")
                {
                    strStatus = "Approved";
                }
                else if (ddlManualEntryStatus.SelectedValue == "Forwarded")
                {
                    strStatus = "Forwarded";
                }
                else if (ddlManualEntryStatus.SelectedValue == "Pending")
                {
                    strStatus = "Pending";
                }
                else if (ddlManualEntryStatus.SelectedValue == "Rejected")
                {
                    strStatus = "Rejected";
                }
                else if (ddlManualEntryStatus.SelectedValue == "Deleted")
                {
                    strStatus = "Deleted";
                }
                else
                {
                    strStatus = "All";
                }
                int shft = 0;
                string Level = string.Empty;
                string employeeName = string.Empty;
                string empName = string.Empty;
                string empId = string.Empty;
                //shft = Convert.ToInt16(this.ddlShift.SelectedValue);
                if (intIndividualUser >= 1)
                {
                    empName = string.Empty;
                    Level = string.Empty;
                    empId = Convert.ToString(Session["EmployeeCodeId"]);
                }
                else
                {
                    empName = Convert.ToString(txtEmployeeName.Text);
                    empId = Convert.ToString(txtEmployeeId.Text.Trim());
                    employeeName = this.txtEmployeeName.Text.Replace("'", "''");
                    employeeName = employeeName.Replace(' ', '%');
                    Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
                }
                //Redirect the page to the report viewer
                string strScript = "";
                strScript = strScript + "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>";
                strScript = strScript + "<meta http-equiv='X-UA-Compatible' content='IE=edge' />";
                strScript = strScript + "<script language='javascript'>";
                strScript = strScript + "window.open('TA_UI_Report_ReportViewer.aspx?ReportName=ManualTimeEntry&dtFrom=" + dtFrom + "&dtTo=" + dtTo + "&empid=" + empId + "&shft=0&EmpName=" + employeeName + "&Level=" + Level + "&EmpCategory=" + Convert.ToInt32(ddlEmpCatagory.SelectedValue) + "&EmpType=" + Convert.ToInt32(ddlEmpType.SelectedValue) + "&ParentLevelId=" + Convert.ToInt16(Session["parentLevelId"]) + "&UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + "&GradeLevel=" + Convert.ToString(Session["GradeLevel"]) + "&Status=" + strStatus + "&SwipeCard=" + Convert.ToString(txtSwipeCard.Text).Trim().Replace("'", "''") + "&Designation=" + Convert.ToInt32(ddlDesignation.SelectedValue) + "&Gender=" + ddlGender.SelectedValue + "','','left=10px, top=60px, width=1000px, height=600px, scrollbars=yes, status=no, resizable=yes');";
                strScript = strScript + "</script>";
                Response.Write(strScript);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    protected void btnSave_Click(object sender, EventArgs e)
    {
        try
        {
            if (Page.IsValid == true)
            {
                string employeeName, Level = string.Empty;
                string empId = string.Empty;
                if (intIndividualUser >= 1)
                {
                    employeeName = string.Empty;
                    Level = string.Empty;
                    empId = Convert.ToString(Session["EmployeeCodeId"]);
                }
                else
                {
                    employeeName = Convert.ToString(txtEmployeeName.Text);
                    empId = Convert.ToString(txtEmployeeId.Text).Trim();
                    employeeName = this.txtEmployeeName.Text.Replace("'", "''");
                    Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
                    if (Level.Contains(","))
                    {
                        Level = Level.Replace(",", "~");
                    }
                    if (employeeName.Contains(","))
                    {
                        employeeName = employeeName.Replace(",", "~");
                    }
                    if (empId.Contains(","))
                    {
                        empId = empId.Replace(",", "~");
                    }
                }
                StringBuilder strFilters = new StringBuilder();
                strFilters.Append("@fromDate=" + " Duration_From " + ",");
                strFilters.Append("@ToDate=" + " Duration_To " + ",");
                strFilters.Append("@EmployeeId=" + empId + ",");
                strFilters.Append("@EmployeeName=" + employeeName + ",");
                strFilters.Append("@LevelID=" + Level + ",");
                strFilters.Append("@EmployeeCategory=" + ddlEmpCatagory.SelectedValue + ",");
                strFilters.Append("@EmployeeType=" + ddlEmpType.SelectedValue + ",");
                strFilters.Append("@UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + ",");
                strFilters.Append("@GradeLevel=" + Convert.ToString(Session["GradeLevel"]) + ",");
                strFilters.Append("@EmpSwipeCard=" + Convert.ToString(txtSwipeCard.Text).Trim().Replace("'", "''") + ",");
                strFilters.Append("@ParentId=" + Convert.ToInt32(Session["parentLevelId"]) + ",");
                strFilters.Append("@Status=" + ddlManualEntryStatus.SelectedValue + ",");
                strFilters.Append("@DesignationID=" + ddlDesignation.SelectedValue + ",");
                strFilters.Append("@Gender=" + ddlGender.SelectedValue + ",");
                strFilters.Append("@EmpAutoId=0");
                Session["hdnReportFilters"] = string.Empty;
                Session["hdnReportFilters"] = strFilters;
                string strScript = "<script language=\"javascript\">";
                strScript = strScript + "{window.top.parent.document.getElementById('ctl00_BodyContentPH_hdnFilters').value='" + strFilters + "'; window.top.parent.document.getElementById('ctl00_BodyContentPH_hdnCompanyId').value='" + Convert.ToInt32(Session["parentLevelId"]) + "';}";
                //strScript = strScript + "self.close();";
                strScript = strScript + "parent.$('#myModalReport').modal('hide');";
                strScript = strScript + "</script>";
                Response.Write(strScript);
            }
        }
        catch
        {
            //
        }
    }
    protected void btnBack_Click(object sender, EventArgs e)
    {
        string strMsg;
        strMsg = "<script language='javascript'>";
        strMsg = strMsg + "parent.$('#myModalReport').modal('hide');";
        strMsg = strMsg + "</script>";
        Page.RegisterStartupScript("close report window", strMsg);
        return;
    }
    protected void btn_Export_Click(object sender, EventArgs e)
    {
        DataSet dsEmp = new DataSet();
        string strStatus = "All";
        string strEmpAutoId = "0";
        try
        {
            if (Session["ReportsBasedOn"] != null)
            {
                if (Convert.ToString(Session["ReportsBasedOn"]) == "False")
                {
                    strEmpAutoId = "0";
                }
                else
                {
                    strEmpAutoId = Convert.ToString(Session["EmpAutoID"]);
                }
            }
            if (Page.IsValid == true)
            {
                string dtFrom = strFromdate;
                string dtTo = strTodate;
                switch (ddlManualEntryStatus.SelectedValue)
                {
                    case "Approved":
                        strStatus = "Approved";
                        break;
                    case "Forwarded":
                        strStatus = "Forwarded";
                        break;
                    case "Pending":
                        strStatus = "Pending";
                        break;
                    case "Rejected":
                        strStatus = "Rejected";
                        break;
                    case "Deleted":
                        strStatus = "Deleted";
                        break;
                    default:
                        strStatus = "All";
                        break;
                }
                int shft = 0;
                string Level = string.Empty;
                string employeeName = string.Empty;
                string empName = string.Empty;
                string empId = string.Empty;
                if (intIndividualUser >= 1)
                {
                    empName = string.Empty;
                    Level = string.Empty;
                    empId = Convert.ToString(Session["EmployeeCodeId"]);
                }
                else
                {
                    empName = Convert.ToString(txtEmployeeName.Text);
                    empId = Convert.ToString(txtEmployeeId.Text.Trim());
                    employeeName = this.txtEmployeeName.Text.Replace("'", "''");
                    employeeName = employeeName.Replace(' ', '%');
                    Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
                }
                dsEmp = rptEmp.SelectManualTimeEntryReport(employeeName, empId, dtFrom, dtTo, Level, Convert.ToInt16(ddlEmpCatagory.SelectedValue), Convert.ToInt16(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), strStatus, Convert.ToString(txtSwipeCard.Text).Trim().Replace("'", "''"), Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt16(ddlDesignation.SelectedValue), ddlGender.SelectedValue, Convert.ToInt32(strEmpAutoId));
                DataTable dtLevelName = new DataTable();
                if (Convert.ToInt16(Session["parentLevelId"]) != 0)
                {
                    dtLevelName = rptEmp.getHeader(Convert.ToInt16(Session["parentLevelId"]));
                }

                if (dsEmp.Tables["Table"] == null || dsEmp.Tables["Table"].Rows.Count == 0)
                {
                    MessagewithClose(rm.GetString("Alert_Thereisnorecord", ci));
                    return;
                }
                else
                {
                    //IsDiscrepancyEntry 
                    //Level Name 
                    //ManualTimeEntry_Date
                    //Modify By 
                    //Modify On
                    
                    if (dsEmp.Tables[0].Columns.Contains("ManualTimeEntry_InPunchType"))
                    {
                        dsEmp.Tables[0].Columns["ManualTimeEntry_InPunchType"].ColumnName = "In Punch Type";
                    }
                    if (dsEmp.Tables[0].Columns.Contains("ManualTimeEntry_OutPunchType"))
                    {
                        dsEmp.Tables[0].Columns["ManualTimeEntry_OutPunchType"].ColumnName = "Out Punch Type";
                    }
                    if (dsEmp.Tables[0].Columns.Contains("IsDiscrepancyEntry"))
                    {
                        dsEmp.Tables[0].Columns["IsDiscrepancyEntry"].ColumnName = "Entry Type";
                    }
                    if (dsEmp.Tables[0].Columns.Contains("Created_By"))
                    {
                        dsEmp.Tables[0].Columns["Created_By"].ColumnName = "Raised By";
                    }
                    if (dsEmp.Tables[0].Columns.Contains("Created_DateTime"))
                    {
                        dsEmp.Tables[0].Columns["Created_DateTime"].ColumnName = "Raised On";
                    }
                    if (dsEmp.Tables[0].Columns.Contains("name"))
                    {
                        dsEmp.Tables[0].Columns["name"].ColumnName = "Level";
                    }

                    if (dsEmp.Tables[0].Columns.Contains("ManualTimeEntry_Id"))
                    {
                        dsEmp.Tables[0].Columns.Remove("ManualTimeEntry_Id");
                    }
                    if (dsEmp.Tables[0].Columns.Contains("TitleName"))
                    {
                        dsEmp.Tables[0].Columns.Remove("TitleName");
                    }
                    if (dsEmp.Tables[0].Columns.Contains("ManualTimeEntry_Date"))
                    {
                        dsEmp.Tables[0].Columns.Remove("ManualTimeEntry_Date");
                    }
                    if (dsEmp.Tables[0].Columns.Contains("Modified_By"))
                    {
                        dsEmp.Tables[0].Columns.Remove("Modified_By");
                    }
                    if (dsEmp.Tables[0].Columns.Contains("Modified_DateTime"))
                    {
                        dsEmp.Tables[0].Columns.Remove("Modified_DateTime");
                    }
                    Session["Export_ExcelData"] = dsEmp;
                    Response.Redirect("Excel_Export.aspx?ReportName=Manual Time Entry&FrmDate=" + Convert.ToString(txtFromDate.Text) + "&toDate=" + Convert.ToString(txtToDate.Text) + "");
                    //ExportExcel(dsEmp, dtLevelName);
                }
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }

    }
    #endregion
    #region Not Used
    /// <summary>
    /// To get the entrance details
    /// </summary>
    private void GetEntranceDetails()
    {
        //DataSet ds_Entrance = new DataSet();
        ////Get the Entrance Name from the Entrance Master 
        //ds_Entrance = objEntrance.SelectEntranceDetails(string.Empty);
        //// If Records Exists, then Fill the Entrance Name DropDown List
        //if (ds_Entrance.Tables[0].Rows.Count > 0)
        //{
        //    // Bind the Entrance Name in the Entrance Name DropDownList
        //    ddlEntrance.DataSource = ds_Entrance;
        //    ddlEntrance.DataTextField = "Entrance_Name";
        //    ddlEntrance.DataValueField = "Entrance_Id";
        //    ddlEntrance.DataBind();
        //}
        //ds_Entrance.Dispose();
    }
    /// <summary>
    /// Display Manual Entry Status in DropDownList
    /// </summary>
    public void LoadManualEntryStatus()
    {
        ddlManualEntryStatus.Items.Insert(0, "All");
        ddlManualEntryStatus.Items.Insert(1, "Approved");
        ddlManualEntryStatus.Items.Insert(2, "Forwarded");
        ddlManualEntryStatus.Items.Insert(3, "Pending");
        ddlManualEntryStatus.Items.Insert(4, "Rejected");
    }
    #endregion
    protected void txtFromDate_TextChanged(object sender, EventArgs e)
    {
    }
}
